From: Arne Meyer <meyer.arne83@netcologne.de>
Date: Wed, 05 Jun 2024 09:22:31 +0000
Subject: [PATCH] nusb/ether: Don't pass ethernet fcs to the network stack for smsc and lan78xx

---
diff 828c577e03e15f59a69bff965893e3a670a8f10f 585b55096bcf7e1e6dbb1152a41daec714fee522
--- a/sys/src/cmd/nusb/ether/lan78xx.c
+++ b/sys/src/cmd/nusb/ether/lan78xx.c
@@ -252,10 +252,11 @@
 			break;
 		if((hd & Rxerror) == 0){
 			if(n == BLEN(b)){
+				b->wr -= 4;
 				etheriq(b);
 				return 0;
 			}
-			etheriq(copyblock(b, n));
+			etheriq(copyblock(b, n - 4));
 		}
 		b->rp = (uchar*)(((uintptr)b->rp + n + 3)&~3);
 	}
--- a/sys/src/cmd/nusb/ether/smsc.c
+++ b/sys/src/cmd/nusb/ether/smsc.c
@@ -228,10 +228,11 @@
 			break;
 		if((hd & Rxerror) == 0){
 			if(n == BLEN(b)){
+				b->wp -= 4;
 				etheriq(b);
 				return 0;
 			}
-			etheriq(copyblock(b, n));
+			etheriq(copyblock(b, n - 4));
 		}
 		b->rp += (n + 3) & ~3;
 	}
